Before submitting an issue, please make sure to search for already open issues, and add to that, you can find already progressing or known issues or feature requests within the Projects tab.
If your are duplicating an already open or issue closely related and that we think may also resolve your issue, we will reference you to that issue and close this one.
This way we can track issues more easily, and try to keep issue information together.

Thank you, and Thanks for using Summernote.

This version of Summernote uses jQuery, if you are using a different version please refer to the relevant repositories below:-
- [Angular](https://github.com/summernote/angular-summernote)
- [dJango](https://github.com/summernote/django-summernote)
- [Rails](https://github.com/summernote/summernote-rails)
- [React](https://github.com/summernote/react-summernote)

If you are requesting for a feature please check [Awesome-Summernote](https://github.com/summernote/awesome-summernote) to see if there has been a plugin the suite's your requirements.

If you are wanting to report an issue with Documentation on the Summernote Website please file an issue at (Summernote)[https://github.com/summernote/summernote.github.io].

Please answer the below questions, this will help us to more easily resolve whatever issues you are having, and direct the issue to the suitable people that can assist with your issue or to give you correct answers.

#### Before reporting an issue please try the following, as this could save you and us a lot of time.
- Check that your Browser and Scripts are up to date, you may need to build Summernote as we continue to fix issues, you can find out how in the [CONTRIBUTING Documentation](https://github.com/summernote/summernote/blob/develop/.github/CONTRIBUTING.md).
- Try to replicate your issue on a blank page to reduce the risk of other Scripts interfering with Summernote producing the issue.
- If another Script is producing the issue along with Summernote, please check with that project in case there are already fixes.

#### Description of your Issue or Request:
Please provide a short description of the issue or request. If you don't provide one (we require more information that just what the Title says), we can't expedite helping to fix your issue or expedite your request, and your issue may simply get closed.

#### steps to reproduce (Add more if necessary):
1.

2.

3.


#### What is your Operating System, Browser and Version and Summernote Version you are using:
This can help find and resolve any issues, place an x inside the brackets or if relevant elaborate after each choice.
1. Operating System:
[ ] Microsoft Windows
[ ] Apple
[ ] Linux
[ ] All

2. Browser and Version:
[ ] Brave
[ ] Chrome
[ ] Edge
[ ] Firefox
[ ] Internet Explorer
[ ] Opera
[ ] Safari
[ ] Other (Specify):

3. Summernote Version, place an x inside the brackets:
[ ] BS3
[ ] BS4
[ ] Lite
[ ] All

#### screenshot of issue
Add screenshot which shows your issue(if needed).
You can make [gif from Recordit](http://www.recordit.co/).

If you can make the issue using jsfiddle(https://jsfiddle.net/), We can save time to reproduce the problem.
